
/*******************************************************************************
*	DISCLAIMER
*
*	THIS SOFTWARE IS PROVIDED "AS IS" AND BFG ENGINEERING MAKES NO WARRANTIES
*	REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING
*	BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
*	PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
*
*	WE (BFG ENGINEERING) DO NOT WARRANT THAT THIS SOFTWARE IS FREE FROM CLAIMS
*	BY A THIRD PARTY OF COPYRIGHT, PATENT, TRADEMARK, TRADE SECRET OR ANY OTHER
*	INTELLECTUAL PROPERTY INFRINGIMENT.
*
*	TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, BFG ENGINEERING
*	SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
*	CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF BFG
*	ENGINEERING HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
*	PARTICULARLY, UNDER NO CIRCUMSTANCES ARE WE LIABLE FOR ANY OF THE FOLLOWING:
*	- THIRD PARTY CLAIMS AGAINST YOU FOR LOSSES OR DAMAGES;
*	- LOSS OF, OR DAMAGE TO YOUR RECORDS OR DATA; OR
*	- ECONOMIC CONSEQUENTIAL DAMAGES (INCLUDING LOST PROFITS OR SAVINGS) OR
*	  INCIDENTAL DAMAGES, EVEN IF WE ARE INFORMED OF THEIR POSSIBILITY.
*
*	BFG ENGINEERING DOES NOT WARRANT UNINTERRUPTED OR ERROR_FREE OPERATION OF
*	THIS SOFTWARE.
*	BFG ENGINEERING HAS NO OBLIGATION TO PROVIDE SERVICE, DEFECT CORRECTION OR
*	ANY MANTEINANCE OF THIS SOFTWARE; OR TO SUPPLY ANY UPDATES OR ENHANCEMENTS
*	EVEN IF SUCH ARE, OR LATER BECOME, AVAILABLE.
*
*	IF YOU DOWNLOAD OR USE THIS SOFTWARE YOU AGREE TO THESE TERMS, AND DO IT AT
*	YOUR OWN RISK.
*******************************************************************************/

/*******************************************************************************
*	File:		globdef.h
*	Project:	MCRP07 RX62T
*	Revision:	7.0
*	Date:		25-10-2013 (DD-MM-YYYY)
*	Author:		Andrea Ghirardello
*	Contents:	Global definitions
*******************************************************************************/

#ifndef	_GLOBDEF_H
#define	_GLOBDEF_H

// inclusions
#include <machine.h>
#include "typedefine.h"
#include "iodefine.h"
#include "globvar.h"
#include "mask.h"
#include "const_def.h"

/* TRUE/FALSE
#ifndef TRUE
	#define TRUE		( 1 )
#endif
#ifndef FALSE
	#define FALSE		( 0 )
#endif
*/

/* NULL/NOP */
#ifndef NULL
	#define NULL		((void *)0)
#endif                        
#ifndef NOP
	#define NOP			{ nop(); }
#endif                        

/* 16bit mul_w(), mulu_w(), div_w(), divu_w() define */
#ifndef MYMULDIV
#define MYMULDIV
#define	mul_w(X, Y)		((s32)(((s16)( X ))*((s16)( Y ))))
#define	mulu_w(X, Y)	((u32)(((u16)( X ))*((u16)( Y ))))
#define	div_w(X, Y)		((s16)(((s32)( X ))/((s16)( Y ))))
#define	divu_w(X, Y)	((u16)(((u32)( X ))/((u16)( Y ))))
#endif	// MYMULDIV

// macro for Module Stop Control
#define WAKEUP_S12AD	{	SYSTEM.MSTPCRA.BIT.MSTPA16=0;	\
							SYSTEM.MSTPCRA.BIT.MSTPA17=0;	\
							SYSTEM.MSTPCRA.BIT.MSTPA24=0;	}
#define STDBY_S12AD		{	SYSTEM.MSTPCRA.BIT.MSTPA16=1;	\
							SYSTEM.MSTPCRA.BIT.MSTPA17=1;	\
							SYSTEM.MSTPCRA.BIT.MSTPA24=1;	}
#define WAKEUP_AD		SYSTEM.MSTPCRA.BIT.MSTPA23=0;
#define STDBY_AD		SYSTEM.MSTPCRA.BIT.MSTPA23=1;
#define WAKEUP_MTU		SYSTEM.MSTPCRA.BIT.MSTPA9=0;
#define STDBY_MTU		SYSTEM.MSTPCRA.BIT.MSTPA9=1;
#define WAKEUP_SCI2		SYSTEM.MSTPCRB.BIT.MSTPB29=0;
#define STDBY_SCI2		SYSTEM.MSTPCRB.BIT.MSTPB29=1;

// macro for A/D conversions
#define INI_S12AD0		{	S12AD0.ADCSR.BYTE=0x0C;		\
							S12AD0.ADANS.WORD=0x0000;	\
							S12AD0.ADCER.WORD=0x0100;	}
#define INI_S12AD1		{	S12AD1.ADCSR.BYTE=0x0C;		\
							S12AD1.ADANS.WORD=0x0000;	\
							S12AD1.ADCER.WORD=0x0100;	}
#define INI_AD0			{	AD0.ADCSR.BYTE=0x00;		\
							AD0.ADDPR.BYTE=0x00;		\
							AD0.ADCR.BYTE=0x0C;			}
#define	S12AD0_START	S12AD0.ADCSR.BIT.ADST=1;	// B7
#define	S12AD0_STOP		S12AD0.ADCSR.BIT.ADST=0;	// B7
#define	S12AD0_C_ON		(S12AD0.ADCSR.BIT.ADST==1)	// B7
#define	WAIT_S12AD0		while(S12AD0_C_ON);
#define	S12AD1_STOP		S12AD1.ADCSR.BIT.ADST=0;	// B7
#define	S12AD1_START	S12AD1.ADCSR.BIT.ADST=1;	// B7
#define	S12AD1_C_ON		(S12AD1.ADCSR.BIT.ADST==1)	// B7
#define	WAIT_S12AD1		while(S12AD1_C_ON);
#define	AD0_START		AD0.ADCSR.BIT.ADST=1;		// B7
#define	AD0_STOP		AD0.ADCSR.BIT.ADST=0;		// B7
#define	AD0_C_ON		(AD0.ADCSR.BIT.ADST==1)		// B7
#define	WAIT_AD0		while(AD0_C_ON);
#define AN000_IW		((unsigned short) S12AD0.ADDR0A)	// PIN91 P40 ANA IN	AN000_UP91	IW
#define AN000_IWA		AN000_IW
#define AN000_IWB		((unsigned short) S12AD0.ADDR0B)	// PIN91 P40 ANA IN	AN000_UP91	IW
#define AN001_IV		((unsigned short) S12AD0.ADDR1)		// PIN90 P41 ANA IN	AN001_UP90	IV
#define AN002_IU		((unsigned short) S12AD0.ADDR2)		// PIN89 P42 ANA IN	AN002_UP89	IU
#define AN003_VB		((unsigned short) S12AD0.ADDR3)		// PIN88 P43 ANA IN	AN003_UP88	VB
#define AN100_IW1		((unsigned short) S12AD1.ADDR0A)	// PIN87 P44 ANA IN	AN100_UP87	IW1
#define AN100_IW1A		AN100_IW1
#define AN100_IW1B		((unsigned short) S12AD1.ADDR0B)	// PIN87 P44 ANA IN	AN100_UP87	IW1
#define AN101_IV1		((unsigned short) S12AD1.ADDR1)		// PIN86 P45 ANA IN	AN101_UP86	IV1
#define AN102_IU1		((unsigned short) S12AD1.ADDR2)		// PIN85 P46 ANA IN	AN102_UP85	IU1
#define AN103_VB1		((unsigned short) S12AD1.ADDR3)		// PIN84 P47 ANA IN	AN103_UP84	VB1
#define	AN0_REF			((unsigned short) AD0.ADDRA)		// PIN77 P60 ANA IN	AN0_UP77	AN0_REF
#define	AN1_POT			((unsigned short) AD0.ADDRB)		// PIN76 P61 ANA IN	AN1_UP76	AN1_POT
#define	AN2_TEMP		((unsigned short) AD0.ADDRC)		// PIN75 P62 ANA IN	AN2_UP75	AN2_TEMP
#define	AN3_TP			((unsigned short) AD0.ADDRD)		// PIN74 P63 ANA IN	AN3_UP74	AN3_TP
#define	AN4_EXT			((unsigned short) AD0.ADDRE)		// PIN70 P64 ANA IN	AN4_UP70	AN4_EXT
#define	AN5_EXT			((unsigned short) AD0.ADDRF)		// PIN69 P65 ANA IN	AN5_UP69	AN5_EXT

// macro for complementary pwm MTU timers 3, 4 (active state = high)
// PIN51	P76 DIG OUT	MTIOC4D_UP51	PWM1_WL
// PIN52	P75 DIG OUT	MTIOC4C_UP52	PWM1_VL
// PIN53	P74 DIG OUT	MTIOC3D_UP53	PWM1_UL
// PIN54	P73 DIG OUT	MTIOC4B_UP54	PWM1_WH
// PIN55	P72 DIG OUT	MTIOC4A_UP55	PWM1_VH
// PIN56	P71 DIG OUT	MTIOC3B_UP56	PWM1_UH
#define	PWM_ALL_OFF_S	0x81		// all pwm pins at inactive level (0)
#define	PWM_HIG_OFF_S	0xF1		// pwm high at inactive level (0)
#define	PWM_LOW_ON_S	0x70		// pwm low at active level (1)
#define	BUF_SP_S		MTU.TCBRA	// buffer for TCDRA (semiper)
#define	BUF_SPD_S		MTU3.TGRC	// buffer for TGRA3 (semiper + deadtime)
#define	BUF_U_S			MTU3.TGRD	// buffer for TGRB3 (duty U)
#define	BUF_V_S			MTU4.TGRC	// buffer for TGRA4 (duty V)
#define	BUF_W_S			MTU4.TGRD	// buffer for TGRB4 (duty W) (LAST TO BE WRITTEN!)
#define SET_ALL_OFF_S	{PORT7.DR.BYTE&=PWM_ALL_OFF_S;}
#define SET_LOW_ON_S	{PORT7.DR.BYTE&=PWM_HIG_OFF_S; PORT7.DR.BYTE|=PWM_LOW_ON_S;}

// macro for complementary pwm MTU timer 6, 7 (active state = low)
// PIN45	P95 DIG OUT	MTIOC6B_UP45	PWM_UH
// PIN46	P94 DIG OUT	MTIOC7A_UP46	PWM_VH
// PIN47	P93 DIG OUT	MTIOC7B_UP47	PWM_WH
// PIN48	P92 DIG OUT	MTIOC6D_UP48	PWM_UL
// PIN49	P91 DIG OUT	MTIOC7C_UP49	PWM_VL
// PIN50	P90 DIG OUT	MTIOC7D_UP50	PWM_WL
#define	PWM_ALL_OFF		0x3F		// all pwm pins at inactive level (1)
#define	PWM_HIG_OFF		0x38		// pwm high at inactive level (1)
#define	PWM_LOW_ON		0xF8		// pwm low at active level (0)
#define	BUF_SP			MTU.TCBRB	// buffer for TCDRB  (semiper)
#define	BUF_SPD			MTU6.TGRC	// buffer for TGRA6 (semiper + deadtime)
#define	BUF_U			MTU6.TGRD	// buffer for TGRB6 (duty U)
#define	BUF_V			MTU7.TGRC	// buffer for TGRA7 (duty V)
#define	BUF_W			MTU7.TGRD	// buffer for TGRB7 (duty W) (LAST TO BE WRITTEN!)
#define SET_ALL_OFF		{PORT9.DR.BYTE|=PWM_ALL_OFF;}
#define SET_LOW_ON		{PORT9.DR.BYTE|=PWM_HIG_OFF; PORT9.DR.BYTE&=PWM_LOW_ON;}

// hardware related general interest defines
#define EXT_SUP_ON		(PORTE.PORT.BIT.B5==0)	// PIN1  PE5 DIG IN PE5_UP1  EXT_SUP_ON
#define EXT_SUP_OFF		(PORTE.PORT.BIT.B5==1)	// PIN1  PE5 DIG IN PE5_UP1  EXT_SUP_ON
#define SW0_ON			(PORT5.PORT.BIT.B0==0)	// PIN83 P50 DIG IN P50_UP83 SW0
#define SW0_OFF			(PORT5.PORT.BIT.B0==1)	// PIN83 P50 DIG IN P50_UP83 SW0
#define SW1_ON			(PORT5.PORT.BIT.B1==0)	// PIN82 P51 DIG IN P51_UP82 SW1
#define SW1_OFF			(PORT5.PORT.BIT.B1==1)	// PIN82 P51 DIG IN P51_UP82 SW1
#define SW2_ON			(PORT5.PORT.BIT.B2==0)	// PIN81 P52 DIG IN P52_UP81 SW2
#define SW2_OFF			(PORT5.PORT.BIT.B2==1)	// PIN81 P52 DIG IN P52_UP81 SW2
#define SW3_ON			(PORT5.PORT.BIT.B3==0)	// PIN80 P53 DIG IN P53_UP80 SW3
#define SW3_OFF			(PORT5.PORT.BIT.B3==1)	// PIN80 P53 DIG IN P53_UP80 SW3
#define SET_DL1			PORT3.DR.BIT.B0=1; 		// PIN63 P30 DIG OUT P30_UP63 DL1
#define CLR_DL1			PORT3.DR.BIT.B0=0; 		// PIN63 P30 DIG OUT P30_UP63 DL1
#define DL1_ON			(PORT3.DR.BIT.B0==1) 	// PIN63 P30 DIG OUT P30_UP63 DL1
#define DL1_OFF			(PORT3.DR.BIT.B0==0) 	// PIN63 P30 DIG OUT P30_UP63 DL1
#define SET_DL2			PORT3.DR.BIT.B1=1;		// PIN61 P31 DIG OUT P31_UP61 DL2
#define CLR_DL2			PORT3.DR.BIT.B1=0;		// PIN61 P31 DIG OUT P31_UP61 DL2
#define DL2_ON			(PORT3.DR.BIT.B1==1)	// PIN61 P31 DIG OUT P31_UP61 DL2
#define DL2_OFF			(PORT3.DR.BIT.B1==0)	// PIN61 P31 DIG OUT P31_UP61 DL2
#define SET_DL3			PORT3.DR.BIT.B2=1;		// PIN59 P32 DIG OUT P32_UP59 DL3
#define CLR_DL3			PORT3.DR.BIT.B2=0;		// PIN59 P32 DIG OUT P32_UP59 DL3
#define DL3_ON			(PORT3.DR.BIT.B2==1)	// PIN59 P32 DIG OUT P32_UP59 DL3
#define DL3_OFF			(PORT3.DR.BIT.B2==0)	// PIN59 P32 DIG OUT P32_UP59 DL3
#define SET_DL4			PORT3.DR.BIT.B3=1;		// PIN58 P33 DIG OUT P33_UP58 DL4
#define CLR_DL4			PORT3.DR.BIT.B3=0;		// PIN58 P33 DIG OUT P33_UP58 DL4
#define DL4_ON			(PORT3.DR.BIT.B3==1)	// PIN58 P33 DIG OUT P33_UP58 DL4
#define DL4_OFF			(PORT3.DR.BIT.B3==0)	// PIN58 P33 DIG OUT P33_UP58 DL4

// global flags (global variables defined in "globvar.h" are used)
#define	TRGED			(flg0.bit.b0!=0)
#define	RBUSY			(flg0.bit.b1!=0)
#define	CSELD			(flg0.bit.b2!=0)
#define	FREE_03			(flg0.bit.b3!=0)
#define	FREE_04			(flg0.bit.b4!=0)
#define	FREE_05			(flg0.bit.b5!=0)
#define	FREE_06			(flg0.bit.b6!=0)
#define	FREE_07			(flg0.bit.b7!=0)

#define	NOT_TRGED		(flg0.bit.b0==0)
#define	NOT_RBUSY		(flg0.bit.b1==0)
#define	NOT_CSELD		(flg0.bit.b2==0)
#define	NOT_FREE_03		(flg0.bit.b3==0)
#define	NOT_FREE_04		(flg0.bit.b4==0)
#define	NOT_FREE_05		(flg0.bit.b5==0)
#define	NOT_FREE_06		(flg0.bit.b6==0)
#define	NOT_FREE_07		(flg0.bit.b7==0)

#define	SET_TRGED		flg0.bit.b0=1;
#define	SET_RBUSY		flg0.bit.b1=1;
#define	SET_CSELD		flg0.bit.b2=1;
#define	SET_FREE_03		flg0.bit.b3=1;
#define	SET_FREE_04		flg0.bit.b4=1;
#define	SET_FREE_05		flg0.bit.b5=1;
#define	SET_FREE_06		flg0.bit.b6=1;
#define	SET_FREE_07		flg0.bit.b7=1;

#define	RES_TRGED		flg0.bit.b0=0;
#define	RES_RBUSY		flg0.bit.b1=0;
#define	RES_CSELD		flg0.bit.b2=0;
#define	RES_FREE_03		flg0.bit.b3=0;
#define	RES_FREE_04		flg0.bit.b4=0;
#define	RES_FREE_05		flg0.bit.b5=0;
#define	RES_FREE_06		flg0.bit.b6=0;
#define	RES_FREE_07		flg0.bit.b7=0;

#define	FREE_10			(flg1.bit.b0!=0)
#define	FREE_11			(flg1.bit.b1!=0)
#define	FREE_12			(flg1.bit.b2!=0)
#define	FREE_13			(flg1.bit.b3!=0)
#define	FREE_14			(flg1.bit.b4!=0)
#define	FREE_15			(flg1.bit.b5!=0)
#define	FREE_16			(flg1.bit.b6!=0)
#define	FREE_17			(flg1.bit.b7!=0)

#define	NOT_FREE_10		(flg1.bit.b0==0)
#define	NOT_FREE_11		(flg1.bit.b1==0)
#define	NOT_FREE_12		(flg1.bit.b2==0)
#define	NOT_FREE_13		(flg1.bit.b3==0)
#define	NOT_FREE_14		(flg1.bit.b4==0)
#define	NOT_FREE_15		(flg1.bit.b5==0)
#define	NOT_FREE_16		(flg1.bit.b6==0)
#define	NOT_FREE_17		(flg1.bit.b7==0)

#define	SET_FREE_10		flg1.bit.b0=1;
#define	SET_FREE_11		flg1.bit.b1=1;
#define	SET_FREE_12		flg1.bit.b2=1;
#define	SET_FREE_13		flg1.bit.b3=1;
#define	SET_FREE_14		flg1.bit.b4=1;
#define	SET_FREE_15		flg1.bit.b5=1;
#define	SET_FREE_16		flg1.bit.b6=1;
#define	SET_FREE_17		flg1.bit.b7=1;

#define	RES_FREE_10		flg1.bit.b0=0;
#define	RES_FREE_11		flg1.bit.b1=0;
#define	RES_FREE_12		flg1.bit.b2=0;
#define	RES_FREE_13		flg1.bit.b3=0;
#define	RES_FREE_14		flg1.bit.b4=0;
#define	RES_FREE_15		flg1.bit.b5=0;
#define	RES_FREE_16		flg1.bit.b6=0;
#define	RES_FREE_17		flg1.bit.b7=0;

#endif	// _GLOBDEF_H

