
/*******************************************************************************
*	DISCLAIMER
*
*	THIS SOFTWARE IS PROVIDED "AS IS" AND BFG ENGINEERING MAKES NO WARRANTIES
*	REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING
*	BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
*	PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
*
*	WE (BFG ENGINEERING) DO NOT WARRANT THAT THIS SOFTWARE IS FREE FROM CLAIMS
*	BY A THIRD PARTY OF COPYRIGHT, PATENT, TRADEMARK, TRADE SECRET OR ANY OTHER
*	INTELLECTUAL PROPERTY INFRINGIMENT.
*
*	TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, BFG ENGINEERING
*	SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
*	CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF BFG
*	ENGINEERING HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
*	PARTICULARLY, UNDER NO CIRCUMSTANCES ARE WE LIABLE FOR ANY OF THE FOLLOWING:
*	- THIRD PARTY CLAIMS AGAINST YOU FOR LOSSES OR DAMAGES;
*	- LOSS OF, OR DAMAGE TO YOUR RECORDS OR DATA; OR
*	- ECONOMIC CONSEQUENTIAL DAMAGES (INCLUDING LOST PROFITS OR SAVINGS) OR
*	  INCIDENTAL DAMAGES, EVEN IF WE ARE INFORMED OF THEIR POSSIBILITY.
*
*	BFG ENGINEERING DOES NOT WARRANT UNINTERRUPTED OR ERROR_FREE OPERATION OF
*	THIS SOFTWARE.
*	BFG ENGINEERING HAS NO OBLIGATION TO PROVIDE SERVICE, DEFECT CORRECTION OR
*	ANY MANTEINANCE OF THIS SOFTWARE; OR TO SUPPLY ANY UPDATES OR ENHANCEMENTS
*	EVEN IF SUCH ARE, OR LATER BECOME, AVAILABLE.
*
*	IF YOU DOWNLOAD OR USE THIS SOFTWARE YOU AGREE TO THESE TERMS, AND DO IT AT
*	YOUR OWN RISK.
*******************************************************************************/

/*******************************************************************************
*	File:		intprg.c
*	Project:	MCRP07 RX62T
*	Revision:	7.0
*	Date:		25-10-2013 (DD-MM-YYYY)
*	Author:		Andrea Ghirardello
*	Contents:	interrupt programs
*******************************************************************************/

#include <machine.h>
#include "vect.h"
#include "motorcontrol.h"
#pragma section IntPRG

// Exception (Supervisor Instruction)
void Excep_SuperVisorInst(void) {/* brk(); */}

// Exception (Undefined Instruction)
void Excep_UndefinedInst(void) {/* brk(); */}

// Exception (Floating Point)
void Excep_FloatingPoint(void) {/* brk(); */}

// NMI
void NonMaskableInterrupt(void) {/* brk(); */}

// Dummy
void Dummy(void) {/* brk(); */}

// BRK
void Excep_BRK(void) { wait(); }

// vector  0, .., 15 reserved

// vector 16	BSC_BUSERR		0040h	level	IER02.IEN0	IPR00
void Excep_BSC_BUSERR(void) { }

// vector 17, ..,20 reserved

// vector 21	FCUIF_FIFERR	0054h	level	IER02.IEN5	IPR01
void Excep_FCUIF_FIFERR(void) { }

// vector 22 reserved

// vector 23	FCUIF_FRDYI		005Ch	edge	IER02.IEN7	IPR02
void Excep_FCUIF_FRDYI(void) { }

// vector 24, ..26 reserved

// vector 27	ICU_SWINT		006Ch	edge	IER03.IEN3	IPR03
void Excep_ICU_SWINT(void) { }

// vector 28	CMT0_CMI0		0070h	edge	IER03.IEN4	IPR04
void Excep_CMT0_CMI0(void) { }

// vector 29	CMT1_CMI1		0074h	edge	IER03.IEN5	IPR05
void Excep_CMT1_CMI1(void) { }

// vector 30	CMT2_CMI2		0078h	edge	IER03.IEN6	IPR06
void Excep_CMT2_CMI2(void) { }

// vector 31	CMT3_CMI3		007Ch	edge	IER03.IEN7	IPR07
void Excep_CMT3_CMI3(void) { }

// vector 32, .., 43 reserved

// vector 44	RSPI0_SPEI0		00B0h	level	IER05.IEN4	IPR14
void Excep_RSPI0_SPEI0(void) { }

// vector 45	RSPI0_SPRI0		00B4h	edge	IER05.IEN5	IPR14
void Excep_RSPI0_SPRI0(void) { }

// vector 46	RSPI0_SPTI0		00B8h	edge	IER05.IEN6	IPR14
void Excep_RSPI0_SPTI0(void) { }

// vector 47	RSPI0_SPII0		00BCh	level	IER05.IEN7	IPR14
void Excep_RSPI0_SPII0(void) { }

// vector 48, .., 55 reserved

// vector 56	CAN0_ERS0		00E0h	edge	IER07.IEN0	IPR18
void Excep_CAN0_ERS0(void) { }

// vector 57	CAN0_RXF0		00E4h	edge	IER07.IEN1	IPR18
void Excep_CAN0_RXF0(void) { }

// vector 58	CAN0_TXF0		00E8h	edge	IER07.IEN2	IPR18
void Excep_CAN0_TXF0(void) { }

// vector 59	CAN0_RXM0		00ECh	edge	IER07.IEN3	IPR18
void Excep_CAN0_RXM0(void) { }

// vector 60	CAN0_TXM0		00F0h	edge	IER07.IEN4	IPR18
void Excep_CAN0_TXM0(void) { }

// vector 61, .., 63 reserved

// vector 64	ICU_IRQ0	0100h	edge/level	IER08.IEN0	IPR20
void Excep_ICU_IRQ0(void) { }

// vector 65	ICU_IRQ1	0100h	edge/level	IER08.IEN1	IPR21
void Excep_ICU_IRQ1(void) { }

// vector 66	ICU_IRQ2	0100h	edge/level	IER08.IEN2	IPR22
void Excep_ICU_IRQ2(void) { }

// vector 67	ICU_IRQ3	0100h	edge/level	IER08.IEN3	IPR23
void Excep_ICU_IRQ3(void) { }

// vector 68	ICU_IRQ4	0100h	edge/level	IER08.IEN4	IPR24
void Excep_ICU_IRQ4(void) { }

// vector 69	ICU_IRQ5	0100h	edge/level	IER08.IEN5	IPR25
void Excep_ICU_IRQ5(void) { }

// vector 70	ICU_IRQ6	0100h	edge/level	IER08.IEN6	IPR26
void Excep_ICU_IRQ6(void) { }

// vector 71	ICU_IRQ7	0100h	edge/level	IER08.IEN7	IPR27
void Excep_ICU_IRQ7(void) { }

// vector 72, .., 95 reserved

// vector 96	WDT_WOVI		0180h	edge	IER0C.IEN0	IPR40
void Excep_WDT_WOVI(void) { }

// vector 97 reserved

// vector 98	AD0_ADI0		0188h	edge	IER0C.IEN2	IPR44
void Excep_AD0_ADI0(void) { }

// vector 99, .., 101 reserved

// vector 102	S12AD0_S12ADI0	0198h	edge	IER0C.IEN6	IPR48
void Excep_S12AD0_S12ADI0(void) { }

// vector 103	S12AD1_S12ADI1	019Ch	edge	IER0C.IEN7	IPR48
void Excep_S12AD1_S12ADI1(void) { }

// vector 104, 105 reserved

// vector 106	CMPB_CMPI		01A8h	edge	IER0D.IEN2	IPR49
void Excep_CMPB_CMPI(void) { }

// vector 107, .., 113 reserved

// vector 114	MTU0_TGIA0		01C8h	edge	IER0E.IEN2	IPR51
void Excep_MTU0_TGIA0(void) { }

// vector 115	MTU0_TGIB0		01CCh	edge	IER0E.IEN3	IPR51
void Excep_MTU0_TGIB0(void) { }

// vector 116	MTU0_TGIC0		01D0h	edge	IER0E.IEN4	IPR51
void Excep_MTU0_TGIC0(void) { }

// vector 117	MTU0_TGID0		01D4h	edge	IER0E.IEN5	IPR51
void Excep_MTU0_TGID0(void) { }

// vector 118	MTU0_TCIV0		01D8h	edge	IER0E.IEN6	IPR52
void Excep_MTU0_TCIV0(void) { }

// vector 119	MTU0_TGIE0		01DCh	edge	IER0E.IEN7	IPR52
void Excep_MTU0_TGIE0(void) { }

// vector 120	MTU0_TGIF0		01E0h	edge	IER0F.IEN0	IPR52
void Excep_MTU0_TGIF0(void) { }

// vector 121	MTU1_TGIA1		01E4h	edge	IER0F.IEN1	IPR53
void Excep_MTU1_TGIA1(void) { }

// vector 122	MTU1_TGIB1		01E8h	edge	IER0F.IEN2	IPR53
void Excep_MTU1_TGIB1(void) { }

// vector 123	MTU1_TCIV1		01ECh	edge	IER0F.IEN3	IPR54
void Excep_MTU1_TCIV1(void) { }

// vector 124	MTU1_TCIU1		01F0h	edge	IER0F.IEN4	IPR54
void Excep_MTU1_TCIU1(void) { }

// vector 125	MTU2_TGIA2		01F4h	edge	IER0F.IEN5	IPR55
void Excep_MTU2_TGIA2(void) { }

// vector 126	MTU2_TGIB2		01F8h	edge	IER0F.IEN6	IPR55
void Excep_MTU2_TGIB2(void) { }

// vector 127	MTU2_TCIV2		01FCh	edge	IER0F.IEN7	IPR56
void Excep_MTU2_TCIV2(void) { }

// vector 128	MTU2_TCIU2		0200h	edge	IER10.IEN0	IPR56
void Excep_MTU2_TCIU2(void) { }

// vector 129	MTU3_TGIA3		0204h	edge	IER10.IEN1	IPR57
void Excep_MTU3_TGIA3(void) { }

// vector 130	MTU3_TGIB3		0208h	edge	IER10.IEN2	IPR57
void Excep_MTU3_TGIB3(void) { }

// vector 131	MTU3_TGIC3		020Ch	edge	IER10.IEN3	IPR57
void Excep_MTU3_TGIC3(void) { }

// vector 132	MTU3_TGID3		0210h	edge	IER10.IEN4	IPR57
void Excep_MTU3_TGID3(void) { }

// vector 133	MTU3_TCIV3		0214h	edge	IER10.IEN5	IPR58
void Excep_MTU3_TCIV3(void) { }

// vector 134	MTU4_TGIA4		0218h	edge	IER10.IEN6	IPR59
void Excep_MTU4_TGIA4(void) { }

// vector 135	MTU4_TGIB4		021Ch	edge	IER10.IEN6	IPR59
void Excep_MTU4_TGIB4(void) { }

// vector 136	MTU4_TGIC4		0220h	edge	IER11.IEN0	IPR59
void Excep_MTU4_TGIC4(void) { }

// vector 137	MTU4_TGID4		0224h	edge	IER11.IEN1	IPR59
void Excep_MTU4_TGID4(void) { }

// vector 138	MTU4_TCIV4		0228h	edge	IER11.IEN2	IPR5A
void Excep_MTU4_TCIV4(void) { MC_ConInt(); }

// vector 139	MTU5_TGIU5		022Ch	edge	IER11.IEN3	IPR5B
void Excep_MTU5_TGIU5(void) { }

// vector 140	MTU5_TGIV5		0230h	edge	IER11.IEN4	IPR5B
void Excep_MTU5_TGIV5(void) { }

// vector 141	MTU5_TGIW5		0234h	edge	IER11.IEN5	IPR5B
void Excep_MTU5_TGIW5(void) { }

// vector 142	MTU6_TGIA6		0238h	edge	IER11.IEN6	IPR5C
void Excep_MTU6_TGIA6(void) { }

// vector 143	MTU6_TGIB6		023Ch	edge	IER11.IEN7	IPR5C
void Excep_MTU6_TGIB6(void) { }

// vector 144	MTU6_TGIC6		0240h	edge	IER12.IEN0	IPR5C
void Excep_MTU6_TGIC6(void) { }

// vector 145	MTU6_TGID6		0244h	edge	IER12.IEN1	IPR5C
void Excep_MTU6_TGID6(void) { }

// vector 146	MTU6_TCIV6		0248h	edge	IER12.IEN2	IPR5D
void Excep_MTU6_TCIV6(void) { }

// vector 147, 148 reserved

// vector 149	MTU7_TGIA7		0254h	edge	IER12.IEN5	IPR5F
void Excep_MTU7_TGIA7(void) { }

// vector 150	MTU7_TGIB7		0258h	edge	IER12.IEN6	IPR5F
void Excep_MTU7_TGIB7(void) { }

// vector 151	MTU7_TGIC7		025Ch	edge	IER12.IEN7	IPR5F
void Excep_MTU7_TGIC7(void) { }

// vector 152	MTU7_TGID7		0260h	edge	IER13.IEN0	IPR5F
void Excep_MTU7_TGID7(void) { }

// vector 153	MTU7_TCIV7		0264h	edge	IER13.IEN1	IPR60
void Excep_MTU7_TCIV7(void) { }

// vector 154, .., 169 reserved

// vector 170	POE_OEI1		02A8h	level	IER15.IEN2	IPR67
void Excep_POE_OEI1(void) { MC_FaultInt(); }

// vector 171	POE_OEI2		02ACh	level	IER15.IEN3	IPR67
void Excep_POE_OEI2(void) { }

// vector 172	POE_OEI3		02B0h	level	IER15.IEN4	IPR67
void Excep_POE_OEI3(void) { }

// vector 173	POE_OEI4		02B4h	level	IER15.IEN5	IPR67
void Excep_POE_OEI4(void) { }

// vector 174	GPT0_GTCIA0		02B8h	edge	IER15.IEN6	IPR68
void Excep_GPT0_GTCIA0(void) { }

// vector 175	GPT0_GTCIB0		02BCh	edge	IER15.IEN7	IPR68
void Excep_GPT0_GTCIB0(void) { }

// vector 176	GPT0_GTCIC0		02C0h	edge	IER16.IEN0	IPR68
void Excep_GPT0_GTCIC0(void) { }

// vector 177	GPT0_GTCIE0		02C4h	edge	IER16.IEN1	IPR69
void Excep_GPT0_GTCIE0(void) { }

// vector 178	GPT0_GTCIV0		02C8h	edge	IER16.IEN2	IPR69
void Excep_GPT0_GTCIV0(void) { }

// vector 179	GPT0_LOCO1		02CCh	edge	IER16.IEN3	IPR69
void Excep_GPT0_LOCO1(void) { }

// vector 180	GPT1_GTCIA1		02D0h	edge	IER16.IEN4	IPR6A
void Excep_GPT1_GTCIA1(void) { }

// vector 181	GPT1_GTCIB1		02D4h	edge	IER16.IEN5	IPR6A
void Excep_GPT1_GTCIB1(void) { }

// vector 182	GPT1_GTCIC1		02D8h	edge	IER16.IEN6	IPR6A
void Excep_GPT1_GTCIC1(void) { }

// vector 183	GPT1_GTCIE1		02DCh	edge	IER16.IEN7	IPR6B
void Excep_GPT1_GTCIE1(void) { }

// vector 184	GPT1_GTCIV1		02E0h	edge	IER17.IEN0	IPR6B
void Excep_GPT1_GTCIV1(void) { }

// vector 185 reserved

// vector 186	GPT2_GTCIA2		02E8h	edge	IER17.IEN1	IPR6C
void Excep_GPT2_GTCIA2(void) { }

// vector 187	GPT2_GTCIB2		02ECh	edge	IER17.IEN2	IPR6C
void Excep_GPT2_GTCIB2(void) { }

// vector 188	GPT2_GTCIC2		02F0h	edge	IER17.IEN3	IPR6C
void Excep_GPT2_GTCIC2(void) { }

// vector 189	GPT2_GTCIE2		02F4h	edge	IER17.IEN4	IPR6D
void Excep_GPT2_GTCIE2(void) { }

// vector 190	GPT2_GTCIV2		02F8h	edge	IER17.IEN5	IPR6D
void Excep_GPT2_GTCIV2(void) { }

// vector 191 reserved

// vector 192	GPT3_GTCIA3		0300h	edge	IER17.IEN6	IPR6E
void Excep_GPT3_GTCIA3(void) { }

// vector 193	GPT3_GTCIB3		0304h	edge	IER17.IEN7	IPR6E
void Excep_GPT3_GTCIB3(void) { }

// vector 194	GPT3_GTCIC3		0308h	edge	IER18.IEN0	IPR6E
void Excep_GPT3_GTCIC3(void) { }

// vector 195	GPT3_GTCIE3		030Ch	edge	IER18.IEN1	IPR6F
void Excep_GPT3_GTCIE3(void) { }

// vector 196	GPT3_GTCIV3		0310h	edge	IER18.IEN2	IPR6F
void Excep_GPT3_GTCIV3(void) { }

// vector 197, .., 213 reserved

// vector 214	SCI0_ERI0		0358h	level	IER1A.IEN6	IPR80
void Excep_SCI0_ERI0(void) { }

// vector 215	SCI0_RXI0		035Ch	edge	IER1A.IEN7	IPR80
void Excep_SCI0_RXI0(void) { }

// vector 216	SCI0_TXI0		0360h	edge	IER1B.IEN0	IPR80
void Excep_SCI0_TXI0(void) { }

// vector 217	SCI0_TEI0		0364h	level	IER1B.IEN1	IPR80
void Excep_SCI0_TEI0(void) { }

// vector 218	SCI1_ERI1		0368h	level	IER1B.IEN2	IPR81
void Excep_SCI1_ERI1(void) { }

// vector 219	SCI1_RXI1		036Ch	edge	IER1B.IEN3	IPR81
void Excep_SCI1_RXI1(void) { }

// vector 220	SCI1_TXI1		0370h	edge	IER1B.IEN4	IPR81
void Excep_SCI1_TXI1(void) { }

// vector 221	SCI1_TEI1		0374h	level	IER1B.IEN5	IPR81
void Excep_SCI1_TEI1(void) { }

// vector 222	SCI2_ERI2		0378h	level	IER1B.IEN6	IPR82
void Excep_SCI2_ERI2(void) { }

// vector 223	SCI2_RXI2		037Ch	edge	IER1B.IEN7	IPR82
void Excep_SCI2_RXI2(void) { }

// vector 224	SCI2_TXI2		0380h	edge	IER1C.IEN0	IPR82
void Excep_SCI2_TXI2(void) { }

// vector 225	SCI2_TEI2		0384h	level	IER1C.IEN1	IPR82
void Excep_SCI2_TEI2(void) { }

// vector 226, .., 245 reserved

// vector 246	RIIC0_ICEEI0	03D8h	level	IER1E.IEN6	IPR88
void Excep_RIIC0_ICEEI0(void) { }

// vector 247	RIIC0_ICRXI0	03E0h	edge	IER1E.IEN7	IPR89
void Excep_RIIC0_ICRXI0(void) { }

// vector 248	RIIC0_ICTXI0	03E4h	edge	IER1F.IEN0	IPR8A
void Excep_RIIC0_ICTXI0(void) { }

// vector 249	RIIC0_ICTEI0	03E4h	level	IER1F.IEN1	IPR8B
void Excep_RIIC0_ICTEI0(void) { }

// vector 250, ..,253 reserved

// vector 254	LIN0_LIN0		03F8h	edge	IER1F.IEN6	IPR90
void Excep_LIN0_LIN0(void) { }

// vector 255 reserved



