
/*******************************************************************************
*	DISCLAIMER
*
*	THIS SOFTWARE IS PROVIDED "AS IS" AND BFG ENGINEERING MAKES NO WARRANTIES
*	REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING
*	BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
*	PURPOSE AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
*
*	WE (BFG ENGINEERING) DO NOT WARRANT THAT THIS SOFTWARE IS FREE FROM CLAIMS
*	BY A THIRD PARTY OF COPYRIGHT, PATENT, TRADEMARK, TRADE SECRET OR ANY OTHER
*	INTELLECTUAL PROPERTY INFRINGIMENT.
*
*	TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, BFG ENGINEERING
*	SHALL NOT BE LIABLE FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR
*	CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF BFG
*	ENGINEERING HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
*	PARTICULARLY, UNDER NO CIRCUMSTANCES ARE WE LIABLE FOR ANY OF THE FOLLOWING:
*	- THIRD PARTY CLAIMS AGAINST YOU FOR LOSSES OR DAMAGES;
*	- LOSS OF, OR DAMAGE TO YOUR RECORDS OR DATA; OR
*	- ECONOMIC CONSEQUENTIAL DAMAGES (INCLUDING LOST PROFITS OR SAVINGS) OR
*	  INCIDENTAL DAMAGES, EVEN IF WE ARE INFORMED OF THEIR POSSIBILITY.
*
*	BFG ENGINEERING DOES NOT WARRANT UNINTERRUPTED OR ERROR_FREE OPERATION OF
*	THIS SOFTWARE.
*	BFG ENGINEERING HAS NO OBLIGATION TO PROVIDE SERVICE, DEFECT CORRECTION OR
*	ANY MANTEINANCE OF THIS SOFTWARE; OR TO SUPPLY ANY UPDATES OR ENHANCEMENTS
*	EVEN IF SUCH ARE, OR LATER BECOME, AVAILABLE.
*
*	IF YOU DOWNLOAD OR USE THIS SOFTWARE YOU AGREE TO THESE TERMS, AND DO IT AT
*	YOUR OWN RISK.
*******************************************************************************/

/*******************************************************************************
*	File:		mask.h
*	Project:	MCRP07 RX62T
*	Revision:	7.0
*	Date:		25-10-2013 (DD-MM-YYYY)
*	Author:		Andrea Ghirardello
*	Contents:	General use mask defines
*******************************************************************************/

#ifndef	_MASK_H
#define	_MASK_H

#define SET0		((unsigned char)(0x01))
#define SET1		((unsigned char)(0x02))
#define SET2		((unsigned char)(0x04))
#define SET3		((unsigned char)(0x08))
#define SET4		((unsigned char)(0x10))
#define SET5		((unsigned char)(0x20))
#define SET6		((unsigned char)(0x40))
#define SET7		((unsigned char)(0x80))

#define CLR0		((unsigned char)(0xFE))
#define CLR1		((unsigned char)(0xFD))
#define CLR2		((unsigned char)(0xFB))
#define CLR3		((unsigned char)(0xF7))
#define CLR4		((unsigned char)(0xEF))
#define CLR5		((unsigned char)(0xDF))
#define CLR6		((unsigned char)(0xBF))
#define CLR7		((unsigned char)(0x7F))

#define WSET0		((unsigned short)(0x0001))
#define WSET1		((unsigned short)(0x0002))
#define WSET2		((unsigned short)(0x0004))
#define WSET3		((unsigned short)(0x0008))
#define WSET4		((unsigned short)(0x0010))
#define WSET5		((unsigned short)(0x0020))
#define WSET6		((unsigned short)(0x0040))
#define WSET7		((unsigned short)(0x0080))
#define WSET8		((unsigned short)(0x0100))
#define WSET9		((unsigned short)(0x0200))
#define WSETA		((unsigned short)(0x0400))
#define WSETB		((unsigned short)(0x0800))
#define WSETC		((unsigned short)(0x1000))
#define WSETD		((unsigned short)(0x2000))
#define WSETE		((unsigned short)(0x4000))
#define WSETF		((unsigned short)(0x8000))

#define WCLR0		((unsigned short)(0xFFFE))
#define WCLR1		((unsigned short)(0xFFFD))
#define WCLR2		((unsigned short)(0xFFFB))
#define WCLR3		((unsigned short)(0xFFF7))
#define WCLR4		((unsigned short)(0xFFEF))
#define WCLR5		((unsigned short)(0xFFDF))
#define WCLR6		((unsigned short)(0xFFBF))
#define WCLR7		((unsigned short)(0xFF7F))
#define WCLR8		((unsigned short)(0xFEFF))
#define WCLR9		((unsigned short)(0xFDFF))
#define WCLRA		((unsigned short)(0xFBFF))
#define WCLRB		((unsigned short)(0xF7FF))
#define WCLRC		((unsigned short)(0xEFFF))
#define WCLRD		((unsigned short)(0xDFFF))
#define WCLRE		((unsigned short)(0xBFFF))
#define WCLRF		((unsigned short)(0x7FFF))

#endif	// _MASK_H

